#!/system/bin/sh

BB=/res/bin/busybox
chmod 755 $BB
alias bb=$BB
alias tb=/system/bin/toybox
PRIME=/data/PRIME-Kernel
HIDE_XPOSED=$(bb cat $PRIME/synapse/settings/hide_xposed_installer)
BAKDIR=$PRIME/xposed-backup
XPOSED_BACKUPS=`bb ls $BAKDIR|bb grep ".data.tar.gz"`

if [ "$HIDE_XPOSED" -eq 1 ]; then
	XPOSED_APK=$(bb cat $PRIME/list/list_xposed_apks.txt)

	if [ "$XPOSED_BACKUPS" != "" ]; then
		for apps in $XPOSED_APK
		do
			test -z "$apps" && continue
			BACKUP_DATA=$BAKDIR/$apps.data.tar.gz
			if [ -f $BACKUP_DATA ] && [ "$(bb ls /data/data/$apps/)" == "" ]; then
				bb mkdir /data/data/$apps && bb chmod 751 /data/data/$apps
				bb tar -xzf $BACKUP_DATA -C /data/data/$apps
				bb chmod 771 /data/data/$apps/shared_prefs
				bb chmod 771 /data/data/$apps/no_backup
				bb chmod 660 /data/data/$apps/shared_prefs/*
				bb chmod 660 /data/data/$apps/no_backup/*
				secon_orig="$(bb cat $PRIME/xposed-backup/$apps.secontexts)"
				secon_sub=$(tb ls -Z /data/data|bb grep $apps|bb cut -d" " -f1)
				if [ "$secon_orig" ]; then
					secon="$secon_orig"
				elif [ "$secon_sub" != "" ]; then
					secon="$secon_sub"
				else
					secon="u:object_r:app_data_file:s0:c512,c768"
				fi
				chcon -R "$secon" /data/data/$apps
				if [ -d /data/user_de/0 ]; then
					bb mkdir /data/user_de/0/$apps && chmod 711 /data/user_de/0/$apps
					bb tar -xzf $BAKDIR/$apps.user.tar.gz -C /data/user_de/0/$apps
					bb chmod 711 /data/user_de/0/$apps
					bb chmod 771 /data/user_de/0/$apps/code_cache
					bb chmod 771 /data/user_de/0/$apps/conf
					bb chmod 777 /data/user_de/0/$apps/log
					bb chmod 400 /data/user_de/0/$apps/code_cache/*
					bb chmod 664 /data/user_de/0/$apps/conf/*
					bb chmod 664 /data/user_de/0/$apps/log/*
					chcon -R $secon /data/user_de/0/$apps
				fi
				break
			fi
		done
	fi
fi
